//+---------------------------------------------------------------------------------+
//|                                                                 Lucky.v.1.2.mq4 |
//|                                          Copyright  2007 Serg_ASV and ak97052d |
//|                                                http://codebase.mql4.com/ru/1555 |
//|     http://www.forex-tsd.com/expert-advisors-metatrader-4/10366-lucky1-1-a.html |
//|                                                                                 |
//| 10.10.2007  v.1   by Serg_ASV                                                   |
//| 25.10.2007  v.1.1 by ak97052d (WeekEndStop/TradingTime/MM/MicroLot)             |   
//| 26.10.2007  v.1.2 by ak97052d (MagicNumber/Slippage/DiferentTradingTimeByChart) |
//|                               [EURGBP][EURCHF][GBPCHF][USDCAD]                  |
//+---------------------------------------------------------------------------------+ :p
 
extern bool    MM        = false; // razmer lota avtomatitchecki chtitaetca
extern bool    RestrictedTradingTime_On = false;
extern bool    ScaleUpOnLosers_On = false;
extern int     MaxOpenOrders = 5;
extern int     Risk      = 10;    // v procentax (%). minimum '1' maximum '100' 
extern double  ManLot    = 0.1;   // razmer lota ecli 'MM=false'
extern int     Shift     = 50; 
extern int     Limit     = 50;
extern int     TP        = 7;
extern int     MinOpenTime = 5;
extern int     MaxOpenTime = 0;
extern int     Slippage  = 3;
extern bool    UsePersoSetting        = false; // if 'false', 'PersoMagic' 'PersoOpenHour' and 'PersoCloseHour' will be used. 
/*--------PersoSetting--------*/
extern int     PersoMagic = 261007;
extern int     PersoOpenHour  = 19;
extern int     PersoCloseHour = 7;
/*--------WeekEndStop--------*/
int            WED1      = 5;    // Day of begin
int            WEH1      = 22;   // Hour of begin
int            WED2      = 1;    // Day of end
int            WEH2      = 2;    // hour of end
//----------------------------------------------------------------------------
bool           first     = true; 
double         MaxLot    = 10;
double         MinLot    = 0.1;
int            LotsDigit = 1;
int            Magic     = 3443959;
double TV,SP,OpenProfit,TotalProfit;
//---------------------------------------------------------------------------- 
int TradingTime,WE,OpenHour,CloseHour,BuyLosers,SellLosers,OpenOrderCount;
double a, b; 

int init()
   { 
   SetInitSettings();
   
   a=Ask; 
   b=Bid; 
   
   }
   
int deinit()
   {
   if (UninitializeReason() == 1)
    GlobalVariableDel("Lucky1.2b_TotalProfit_"+Symbol());
   }
   
int start() 
   {
    
    if (OpenOrderCount < MaxOpenOrders && WEstop() == 0 && Tradetime() == 1)
      {
      if (Bid-b>=(Shift+(SellLosers>BuyLosers)*10)*Point) 
         {
         OrderSend(Symbol(),OP_SELL,GetLots(),Bid,Slippage,0,0,"Lucky",Magic,0,Red);
         }  
      if (a-Ask>=(Shift+(BuyLosers>SellLosers)*10)*Point) 
         {
         OrderSend(Symbol(),OP_BUY,GetLots(),Ask,Slippage,0,0,"Lucky",Magic,0,Blue);
         } 
      }
    a=Ask;  
    b=Bid; 
  
    OpenOrderCount = CloseAll();
    
    if (!IsTesting() || IsVisualMode())
     Comment("Open Orders = ",OpenOrderCount,"\nOpen Profit = "+DoubleToStr(OpenProfit,2)+"\nClosed Profit = "+DoubleToStr(TotalProfit,2)
      +"\n\n(BuyLosers = ",BuyLosers,"  SellLosers = ",SellLosers+")");
    
    return(0);
    
   }

//----------------------------------------------------------------------------- 
int CloseAll() 
   { 
   int col,OrderCount;
   double Price,sl;
   
   OpenProfit = 0;
   
   for (int cnt = OrdersTotal()-1 ; cnt >= 0; cnt--) 
      { 
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES); 
      if (OrderSymbol() == Symbol() && OrderMagicNumber()==Magic) 
         { 
         OpenProfit = OpenProfit + OrderProfit();
         OrderCount++;
         
         if (OrderType() == OP_BUY) {
          Price = Bid;
          sl = (OrderOpenPrice()-Ask) / Point;
          col = Blue; }
         else if (OrderType() == OP_SELL) {
          Price = Ask;
          sl = (Bid-OrderOpenPrice()) / Point;
          col = Red; }
         
         if (SecurProfit()==1 || Tradetime() == 0 || sl > Limit)
            { 
            if (OrderClose(OrderTicket(),OrderLots(),Price,Slippage,col)) {
             TotalProfit = GlobalVariableGet("Lucky1.2b_TotalProfit_"+Symbol()) + OrderProfit(); 
             GlobalVariableSet("Lucky1.2b_TotalProfit_"+Symbol(),TotalProfit);
             OrderCount--; } 
             if (OrderProfit() < 0) {
              if (OrderType() ==OP_BUY)
               BuyLosers++;
              else SellLosers++; }
            } 
         
         } 
      } 
      return(OrderCount);
   } 
//--------------------------------------------------------------------------
int WEstop()
   {
   WE=0;
   if (TimeHour(TimeCurrent()) > WEH1 && DayOfWeek() == WED1) WE=1;
   if (TimeHour(TimeCurrent()) < WEH2 && DayOfWeek() == WED2) WE=2;
   return(WE);
   }
//-------------------------------------------------------------------------- 
int Tradetime()
   {
   TradingTime=0;
   if (!RestrictedTradingTime_On || (TimeHour(TimeCurrent()) >= OpenHour || TimeHour(TimeCurrent())< CloseHour))   TradingTime=1;
   return(TradingTime); 
   }
//-------------------------------------------------------------------------- 
double GetLots() 
   {
   double lots,MD,RM,FMM,MinLot,MaxLot; int lotsdigit;
   MD = NormalizeDouble(MarketInfo(Symbol(), MODE_LOTSTEP), 2); // chag mejdu lotami (0.1 ili 0.01)pomojit nam uznat ecli eto micro accunt ili net
   RM = NormalizeDouble(MarketInfo(Symbol(), MODE_MARGINREQUIRED), 4);
   FMM = (RM+5)*100;
   if (MD==0.01) lotsdigit=2;
   else lotsdigit=1;
   LotsDigit=lotsdigit;
   if (MM==true) lots = NormalizeDouble(AccountFreeMargin()/(FMM/Risk)-0.05,LotsDigit);
   else lots=ManLot;
   if (ScaleUpOnLosers_On && OpenProfit < 0)
    lots = lots + MathAbs(OpenProfit) / MarketInfo(Symbol(),MODE_TICKVALUE) / TP / 5;
   MinLot=NormalizeDouble(MarketInfo(Symbol(),MODE_MINLOT),2);    // minimalnaia pozvolena stavka
   MaxLot=NormalizeDouble(MarketInfo(Symbol(), MODE_MAXLOT),2);   // maximalnaia pozvolena stavka
   if (LotsDigit == 2) MinLot = 0.01; 
   if (lots < MinLot) lots = MinLot;  
   if (lots > MaxLot) lots = MaxLot;     
   return (lots);      
   }
//-------------------------------------------------------------------------
double TickValue() // 
   {
   double tv;
   tv = NormalizeDouble(MarketInfo(Symbol(), MODE_TICKVALUE), 4); // pribl za 1 pip c 1 lot
   return(tv);
   }

int SecurProfit()
   {
   int sp=0;
   if (OrderProfit()>(TickValue()*OrderLots()*TP)
    || (MinOpenTime > 0 && iTime(NULL,PERIOD_M1,0) > OrderOpenTime() + MinOpenTime * 60
     && OrderProfit() > TP * MarketInfo(Symbol(),MODE_TICKVALUE) * OrderLots() / 2)
    || (MaxOpenTime > 0 && iTime(NULL,PERIOD_M1,0) > OrderOpenTime() + MaxOpenTime * 60)) sp=1; // ecli pribilnix ticksov viche 'TP'. rezultat 'SecurProfit()' budit '1'
   return(sp);
   }   
 void SetInitSettings()
   {
   if (UsePersoSetting == false)
      {
      if (Symbol() == "EURGBPm" || Symbol() == "EURGBP") 
         {
         Magic = 1001; OpenHour  = 19; CloseHour = 7;
         }
      if (Symbol() == "EURCHFm" || Symbol() == "EURCHF") 
         {
         Magic = 1010; OpenHour  = 19; CloseHour = 7;
         }
      if (Symbol() == "GBPCHFm" || Symbol() == "GBPCHF") 
         {
         Magic = 1011; OpenHour  = 19; CloseHour = 7;
         }
      if (Symbol() == "USDCADm" || Symbol() == "USDCAD") 
         {
         Magic = 1100; OpenHour  = 1; CloseHour = 13;
         }
// add here other chart config
      if (Magic == 0) 
         {
         Magic = 1000; OpenHour  = 19; CloseHour = 7;
         }
      }
   else 
      {
      Magic = PersoMagic; OpenHour  = PersoOpenHour; CloseHour = PersoCloseHour;
      }
   
   if (!GlobalVariableCheck("Lucky1.2b_TotalProfit_"+Symbol()))
    GlobalVariableSet("Lucky1.2b_TotalProfit_"+Symbol(),0);
   else TotalProfit = GlobalVariableGet("Lucky1.2b_TotalProfit_"+Symbol());
   }  
   
   
   
   
   